﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using TsmCode;
using TsmSupervisor;

namespace UiCalculator
{
  class Keyboard : TsmPComponent
  {
    private Buttons mButtons;

    public Keyboard( TsmBase oParent )
    {
      TsmName = "Keyboard";
      TsmParent = oParent;

      mButtons = new Buttons();
    }

    public override void SetRequiredInterface( string sPortName, TsmInterfacePort oProvidedInterface )
    {
      switch( sPortName )
      {
      case "d_rp_calc" :
        mButtons.SetRequiredInterface( oProvidedInterface );
        break;
      default :
        string s;
        s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > UI )";
        throw new Exception( s );
      }
    }
  }

  public class Buttons : TsmClass
  {
    private TsmIPort_ICalculator Port;  // ( Xmi > Data > Protocols > CalculatorProtocol > CalculatorClient > Port )

    public Buttons()
    {
      Storage.Buttons = this;
    }
    
    public void SetRequiredInterface( TsmInterfacePort oProvidedInterface )
    {
      Port = (TsmIPort_ICalculator) oProvidedInterface;
      Port.Source = this;
    }

    public void Input( char c )
    {
      switch ( c )
      {
      case '+':
      case '-':
      case '*':
      case '/':
        Port.Oper( c );
        break;
      case '=':
        Port.Equals();
        break;
      case '.':
        Port.Point();
        break;
      case '0':
        Port.Digit_0();
        break;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        Port.Digit_1_9( c );
        break;
      case 'e':
        Port.CancelEntry();
        break;
      case 'c':
        Port.Cancel();
        break;
      case 'q':
        Port.Off();
        break;
      }
    }
  }
}
