﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace UiCalculator
{
  static class Program
  {
    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    [STAThread]
    static void Main()
    {
      TsmSystem ts = new TsmSystem( null );
      ts.Activate();

      /*
       * In this application, the function  ts.Execute()  is not
       * called, because it has no effect since there are
       * no modeled threads.
       *
       * Note that calling this function in a ui-driven application
       * having modeled threads should be done in an additional thread,
       * since otherwise it would block the ui.
       */

      Application.EnableVisualStyles();
      Application.SetCompatibleTextRenderingDefault( false );
      Application.Run( new ui() );

      ts.Deactivate();
    }
  }
}
